package com.sf.vertx.handle;

import com.sf.vertx.security.MainSecurity;

import io.vertx.core.Future;
import io.vertx.core.buffer.Buffer;
import io.vertx.core.http.HttpClient;
import io.vertx.core.http.PoolOptions;
import io.vertx.core.json.JsonObject;
import io.vertx.ext.web.Router;
import io.vertx.ext.web.RoutingContext;
import io.vertx.ext.web.client.WebClient;
import io.vertx.httpproxy.Body;
import io.vertx.httpproxy.HttpProxy;
import io.vertx.httpproxy.ProxyRequest;
import io.vertx.httpproxy.ProxyResponse;
import lombok.extern.slf4j.Slf4j;

/**
 * @author <a href="mailto:emad.albloushi@gmail.com">Emad Alblueshi</a>
 */
@Slf4j
public class ProxyHandlerImpl implements ProxyHandler {

	private final HttpProxy httpProxy;
	private WebClient mainWebClient;

	public ProxyHandlerImpl(WebClient mainWebClient, HttpProxy httpProxy) {
		this.httpProxy = httpProxy;
		this.mainWebClient = mainWebClient;
	}

	public ProxyHandlerImpl(HttpProxy httpProxy) {
		this.httpProxy = httpProxy;
	}

	public ProxyHandlerImpl(HttpProxy httpProxy, int port, String host) {
		this.httpProxy = httpProxy.origin(port, host);
	}

	@Override
	public void handle(RoutingContext ctx) {
		// 创建一个响应并设置参数
//		ctx.request().response().setStatusCode(200)
//				.putHeader("content-type", "text/plain").end(body);
		// 发起一个请求

//		this.mainWebClient.post(9198, "127.0.0.1", "/vertx/body").sendJson(ctx.getBodyAsString(), h -> {
//			if (h.succeeded()) {
//				JsonObject responseData = h.result().bodyAsJsonObject();
//				log.info("responseData:{}", responseData);
//				// 加密
//				String dataStr = MainSecurity.aesEncrypt(responseData.toString(), "dadddsdfadfadsfa33323223");
//				log.info("dataStr:{}", dataStr);
//				ctx.request().response().setStatusCode(200).putHeader("content-type", "application/json").end(dataStr);
//			}
//		});

		// 原始代码只有如下一句
		httpProxy.handle(ctx.request());
	}
}